﻿-----------------------------------------------------------------------
-- AddOn namespace.
-----------------------------------------------------------------------
local ADDON_NAME, private = ...

local LibStub = _G.LibStub
local AL = LibStub("AceLocale-3.0"):GetLocale("RareScanner", false)

-- RARE names
AL["EN_RARE_LIST"] = {
	-- Rares Pandaria
	["Aeonaxx"] = 50062; --Aeonaxx
	["Aetha"] = 58778; --Aetha
	["Aethis"] = 50750; --Aethis
	["Ahone the Wanderer"] = 50817; --Ahone the Wanderer
	["Ai-Li Skymirror"] = 50821; --Ai-Li Skymirror
	["Ai-Ran the Shifting Cloud"] = 50822; --Ai-Ran the Shifting Cloud
	["Al'tabim the All-Seeing"] = 70000; --Al'tabim the All-Seeing
	["Ankha"] = 54318; --Ankha
	["Anthriss"] = 54338; --Anthriss
	["Archiereus of Flame"] = 73666; --Archiereus of Flame
	["Archritualist Kelada"] = 70243; --Archritualist Kelada
	["Arness the Scale"] = 50787; --Arness the Scale
	["Backbreaker Uru"] = 70001; --Backbreaker Uru
	["Bai-Jin the Butcher"] = 58949; --Bai-Jin the Butcher
	["Ban'thalos"] = 54320; --Ban'thalos
	["Baolai the Immolator"] = 63695; --Baolai the Immolator
	["Blackhoof"] = 51059; --Blackhoof
	["Bloodtip"] = 58474; --Bloodtip
	["Bonobos"] = 50828; --Bonobos
	["Borginn Darkfist"] = 50341; --Borginn Darkfist
	["Bufo"] = 72775; --Bufo
	["Champion of the Black Flame"] = 73171; --Champion of the Black Flame
	["Chelon"] = 72045; --Chelon
	["Cinderfall"] = 73175; --Cinderfall
	["Cournith Waterstrider"] = 50768; --Cournith Waterstrider
	["Cracklefang"] = 58768; --Cracklefang
	["Cranegnasher"] = 72049; --Cranegnasher
	["Dak the Breaker"] = 50334; --Dak the Breaker
	["Dalan Nightbreaker"] = 68318; --Dalan Nightbreaker
	["Deth'tilac"] = 54322; --Deth'tilac
	["Disha Fearwarden"] = 68319; --Disha Fearwarden
	["Doctor Theolen Krastinov"] = 59369; --Doctor Theolen Krastinov
	["Dread Ship Vazuvius"] = 73281; --Dread Ship Vazuvius
	["Emerald Gander"] = 73158; --Emerald Gander
	["Eshelon"] = 50772; --Eshelon
	["Evermaw"] = 73279; --Evermaw
	["Ferdinand"] = 51078; --Ferdinand
	["Flesh'rok the Diseased"] = 70429; --Flesh'rok the Diseased
	["Flintlord Gairan"] = 73172; --Flintlord Gairan
	["Focused Eye"] = 70249; --Focused Eye
	["Gaarn the Toxic"] = 50340; --Gaarn the Toxic
	["Gaohun the Soul-Severer"] = 62881; --Gaohun the Soul-Severer
	["Gar'lok"] = 50739; --Gar'lok
	["Garnia"] = 73282; --Garnia
	["General Temuja"] = 63101; --General Temuja
	["Ghostcrawler"] = 50051; --Ghostcrawler
	["Go-Kan"] = 50331; --Go-Kan
	["Gochao the Ironfist"] = 62880; --Gochao the Ironfist
	["God-Hulk Ramuk"] = 69999; --God-Hulk Ramuk
	["Goda"] = 69998; --Goda
	["Golganarr"] = 72970; --Golganarr
	["Great Turtle Furyshell"] = 73161; --Great Turtle Furyshell
	["Gu'chi the Swarmbringer"] = 72909; --Gu'chi the Swarmbringer
	["Havak"] = 50354; --Havak
	["Haywire Sunreaver Construct"] = 50358; --Haywire Sunreaver Construct
	["Huo-Shuang"] = 63691; --Huo-Shuang
	["Huolon"] = 73167; --Huolon
	["Ik-Ik the Nimble"] = 50836; --Ik-Ik the Nimble
	["Imperial Python"] = 73163; --Imperial Python
	["Ironfur Steelhorn"] = 73160; --Ironfur Steelhorn
	["Jadefang"] = 49822; --Jadefang
	["Jakur of Ordon"] = 73169; --Jakur of Ordon
	["Jonn-Dar"] = 50351; --Jonn-Dar
	["Kah'tir"] = 50355; --Kah'tir
	["Kal'tik the Blight"] = 50749; --Kal'tik the Blight
	["Kang the Soul Thief"] = 50349; --Kang the Soul Thief
	["Kar Warmaker"] = 68321; --Kar Warmaker
	["Karkanos"] = 72193; --Karkanos
	["Karkin"] = 50959; --Karkin
	["Karoma"] = 50138; --Karoma
	["Karr the Darkener"] = 50347; --Karr the Darkener
	["Kirix"] = 54323; --Kirix
	["Kor'nas Nightsavage"] = 50338; --Kor'nas Nightsavage
	["Korda Torros"] = 50332; --Korda Torros
	["Krakkanon"] = 70323; --Krakkanon
	["Krax'ik"] = 50363; --Krax'ik
	["Kri'chon"] = 63978; --Kri'chon
	["Krol the Blade"] = 50356; --Krol the Blade
	["Ku'lai the Skyclaw"] = 69996; --Ku'lai the Skyclaw
	["Leafmender"] = 73277; --Leafmender
	["Lith'ik the Stalker"] = 50734; --Lith'ik the Stalker
	["Lon the Bull"] = 50333; --Lon the Bull
	["Lu-Ban"] = 70002; --Lu-Ban
	["Magria"] = 54319; --Magria
	["Major Nanners"] = 50840; --Major Nanners
	["Mavis Harms"] = 68317; --Mavis Harms
	["Mister Ferocious"] = 50823; --Mister Ferocious
	["Moldo One-Eye"] = 50806; --Moldo One-Eye
	["Molthor"] = 70003; --Molthor
	["Monara"] = 70440; --Monara
	["Monstrous Spineclaw"] = 73166; --Monstrous Spineclaw
	["Morgrinn Crackfang"] = 50350; --Morgrinn Crackfang
	["Muerta"] = 68322; --Muerta
	["Mumta"] = 69664; --Mumta
	["Nal'lak the Ripper"] = 50364; --Nal'lak the Ripper
	["Nalash Verdantis"] = 50776; --Nalash Verdantis
	["Nasra Spothide"] = 50811; --Nasra Spothide
	["Nessos the Oracle"] = 50789; --Nessos the Oracle
	["No'ku Stormsayer"] = 70276; --No'ku Stormsayer
	["Norlaxx"] = 50344; --Norlaxx
	["Omnis Grinlok"] = 50805; --Omnis Grinlok
	["Overlord Sunderfury"] = 50085; --Overlord Sunderfury
	["Prince Lakma"] = 54533; --Prince Lakma
	["Progenitus"] = 69997; --Progenitus
	["Qu'nas"] = 50352; --Qu'nas
	["Quid"] = 58771; --Quid
	["Ra'sha"] = 70530; --Ra'sha
	["Rattleskew"] = 72048; --Rattleskew
	["Rock Moss"] = 73157; --Rock Moss
	["Rocky Horror"] = 70430; --Rocky Horror
	["Ruun Ghostpaw"] = 50816; --Ruun Ghostpaw
	["Sahn Tidehunter"] = 50780; --Sahn Tidehunter
	["Salyin Warscout"] = 50783; --Salyin Warscout
	["Sambas"] = 50159; --Sambas
	["Sarnak"] = 50782; --Sarnak
	["Scritch"] = 50831; --Scritch
	["Sele'na"] = 50766; --Sele'na
	["Shadowmaster Sydow"] = 63240; --Shadowmaster Sydow
	["Siltriss the Sharpener"] = 50791; --Siltriss the Sharpener
	["Skarr"] = 50815; --Skarr
	["Ski'thik"] = 50733; --Ski'thik
	["Skitterflame"] = 54324; --Skitterflame
	["Solix"] = 54321; --Solix
	["Spelurk"] = 71864; --Spelurk
	["Spirit of Jadefire"] = 72769; --Spirit of Jadefire
	["Spirit of Lao-Fe"] = 58817; --Spirit of Lao-Fe
	["Spriggin"] = 50830; --Spriggin
	["Stinkbraid"] = 73704; --Stinkbraid
	["Sulik'shor"] = 50339; --Sulik'shor
	["Tarvus the Vile"] = 50086; --Tarvus the Vile
	["The Yowler"] = 50832; --The Yowler
	["Torik-Ethis"] = 50388; --Torik-Ethis
	["Tsavo'ka"] = 72808; --Tsavo'ka
	["Ubunti the Shade"] = 68320; --Ubunti the Shade
	["Unblinking Eye"] = 70238; --Unblinking Eye
	["Urdur the Cauterizer"] = 73173; --Urdur the Cauterizer
	["Urgolax"] = 50359; --Urgolax
	["Urobi the Walker"] = 50808; --Urobi the Walker
	["Vicejaw"] = 58769; --Vicejaw
	["Vyraxxis"] = 63977; --Vyraxxis
	["War-God Dokah"] = 70096; --War-God Dokah
	["Watcher Osu"] = 73170; --Watcher Osu
	["Whizzig"] = 73293; --Whizzig
	["Willy Wilder"] = 70126; --Willy Wilder
	["Wulon"] = 63510; --Wulon
	["Yorik Sharpeye"] = 50336; --Yorik Sharpeye
	["Yul Wildpaw"] = 50820; --Yul Wildpaw
	["Zai the Outcast"] = 50769; --Zai the Outcast
	["Zandalari Warbringer"] = 69769; --Zandalari Warbringer cian
	["Zandalari Warbringer"] = 69842; --Zandalari Warbringer gray
	["Zandalari Warbringer"] = 69841; --Zandalari Warbringer silver
	["Zandalari Warscout"] = 69768; --Zandalari Warscout
	["Zao'cho"] = 69843; --Zao'cho
	["Zesqua"] = 72245; --Zesqua
	["Zhu-Gon the Sour"] = 71919; --Zhu-Gon the Sour
	
	-- Rares Draenor
	["Amaukwa"] = 77140; --Amaukwa
	["Ancient Blademaster"] = 82899; --Ancient Blademaster
	["Aqualir"] = 86213; --Aqualir
	["Avatar of Socrethar"] = 88043; --Avatar of Socrethar
	["Ba'ruun"] = 82326; --Ba'ruun
	["Bahameye"] = 81406; --Bahameye
	["Bashiok"] = 82085; --Bashiok
	["Beastcarver Saramor"] = 78150; --Beastcarver Saramor
	["Betsi Boombasket"] = 84887; --Betsi Boombasket
	["Blade-Dancer Aeryx"] = 80614; --Blade-Dancer Aeryx
	["Blightglow"] = 84856; --Blightglow
	["Brambleking Fili"] = 81639; --Brambleking Fili
	["Breathless"] = 78867; --Breathless
	["Brutag Grimblade"] = 87234; --Brutag Grimblade
	["Canyon Icemother"] = 71721; --Canyon Icemother
	["Char the Burning"] = 82311; --Char the Burning
	["Chillfang"] = 80242; --Chillfang
	["Cindermaw"] = 72294; --Cindermaw
	["Cloudspeaker Daber"] = 78169; --Cloudspeaker Daber
	["Coldstomp the Griever"] = 77513; --Coldstomp the Griever
	["Coldtusk"] = 76914; --Coldtusk
	["Cro Fleshrender"] = 77620; --Cro Fleshrender
	["Cyclonic Fury"] = 78621; --Cyclonic Fury
	["Dark Emanation"] = 77085; --Dark Emanation
	["Darkmaster Go'vid"] = 82268; --Darkmaster Go'vid
	["Darktalon"] = 82411; --Darktalon
	["Deadshot Kizi"] = 77763; --Deadshot Kizi
	["Depthroot"] = 82058; --Depthroot
	["Direhoof"] = 86729; --Direhoof
	["Dr. Gloom"] = 77561; --Dr. Gloom
	["Durkath Steelmaw"] = 84807; --Durkath Steelmaw
	["Elementalist Utrah"] = 77768; --Elementalist Utrah
	["Enavra"] = 82676; --Enavra
	["Enavra"] = 82742; --Enavra
	["Faebright"] = 82207; --Faebright
	["Fangler"] = 82975; --Fangler
	["Felbark"] = 80204; --Felbark
	["Felfire Consort"] = 82992; --Felfire Consort
	["Festerbloom"] = 84890; --Festerbloom
	["Firefury Giant"] = 74971; --Firefury Giant
	["Firestarter Grash"] = 88580; --Firestarter Grash
	["Flinthide"] = 83483; --Flinthide
	["Forge Matron Targa"] = 77648; --Forge Matron Targa
	["Fossilwood the Petrified"] = 85250; --Fossilwood the Petrified
	["Frenzied Golem"] = 77614; --Frenzied Golem
	["Galzomar"] = 78713; --Galzomar
	["Gar'lua"] = 82764; --Gar'lua
	["Garrison Ford"] = 86058; --Garrison Ford
	["Gelgor of the Blue Flame"] = 81038; --Gelgor of the Blue Flame
	["General Aevd"] = 82882; --General Aevd
	["Gennadian"] = 80471; --Gennadian
	["Giant-Slayer Kul"] = 71665; --Giant-Slayer Kul
	["Giantslayer Kimla"] = 78144; --Giantslayer Kimla
	["Glimmerwing"] = 77719; --Glimmerwing
	["Glut"] = 80868; --Glut
	["Gnarlhoof the Rabid"] = 82778; --Gnarlhoof the Rabid
	["Gorum"] = 76380; --Gorum
	["Grand Marshal Tremblade"] = 82876; --Grand Marshal Tremblade
	["Greatfeather"] = 82758; --Greatfeather
	["Greldrok the Cunning"] = 84431; --Greldrok the Cunning
	["Grizzlemaw"] = 82912; --Grizzlemaw
	["Gronnstalker Dawarn"] = 78128; --Gronnstalker Dawarn
	["Grove Warden Yal"] = 88583; --Grove Warden Yal
	["Grutush the Pillager"] = 80312; --Grutush the Pillager
	["Gruuk"] = 80190; --Gruuk
	["Gurun"] = 80235; --Gurun
	["Haakun the All-Consuming"] = 83008; --Haakun the All-Consuming
	["Hammertooth"] = 77715; --Hammertooth
	["Hen-Mother Hami"] = 77626; --Hen-Mother Hami
	["Hermit Palefur"] = 86724; --Hermit Palefur
	["High Warlord Volrath"] = 82877; --High Warlord Volrath
	["Hunter Bal'ra"] = 88672; --Hunter Bal'ra
	["Hunter Blacktooth"] = 83603; --Hunter Blacktooth
	["Huntmaster Kuang"] = 78151; --Huntmaster Kuang
	["Hyperious"] = 78161; --Hyperious
	["Insha'tar"] = 83553; --Insha'tar
	["Jabberjaw"] = 82616; --Jabberjaw
	["Jaluk the Pacifist"] = 87600; --Jaluk the Pacifist
	["Jiasska the Sporegorger"] = 84955; --Jiasska the Sporegorger
	["Kalos the Bloodbathed"] = 84810; --Kalos the Bloodbathed
	["Karosh Blackwind"] = 86959; --Karosh Blackwind
	["Kharazos the Triumphant"] = 78710; --Kharazos the Triumphant
	["Killmaw"] = 74206; --Killmaw
	["Klikixx"] = 78872; --Klikixx
	["Ku'targ the Voidseer"] = 72362; --Ku'targ the Voidseer
	["Lady Temptessa"] = 85121; --Lady Temptessa
	["Leaf-Reader Kurri"] = 72537; --Leaf-Reader Kurri
	["Lo'marg Jawcrusher"] = 77784; --Lo'marg Jawcrusher
	["Lord Korinak"] = 82920; --Lord Korinak
	["Mad \"King\" Sporeon"] = 77310; --Mad "King" Sporeon
	["Malroc Stonesunder"] = 83643; --Malroc Stonesunder
	["Mandrakor"] = 84406; --Mandrakor
	["Marshal Gabriel"] = 82878; --Marshal Gabriel
	["Marshal Karsh Stormforge"] = 82880; --Marshal Karsh Stormforge
	["Matron of Sin"] = 82998; --Matron of Sin
	["Morva Soultwister"] = 82362; --Morva Soultwister
	["Mother Araneae"] = 76473; --Mother Araneae
	["Mother Om'ra"] = 75071; --Mother Om'ra
	["Mutafen"] = 84417; --Mutafen
	["Nas Dunberlin"] = 82247; --Nas Dunberlin
	["No'losh"] = 79334; --No'losh
	["Ophiis"] = 83409; --Ophiis
	["Oskiira the Vengeful"] = 84872; --Oskiira the Vengeful
	["Outrider Duretha"] = 83680; --Outrider Duretha
	["Pale Fishmonger"] = 78606; --Pale Fishmonger
	["Pathfinder Jalog"] = 78134; --Pathfinder Jalog
	["Pathstalker Draga"] = 77095; --Pathstalker Draga
	["Pit Beast"] = 88208; --Pit Beast
	["Poisonmaster Bortusk"] = 84838; --Poisonmaster Bortusk
	["Primalist Mur'og"] = 76918; --Primalist Mur'og
	["Pyrecaster Zindra"] = 77642; --Pyrecaster Zindra
	["Ra'kahn"] = 77741; --Ra'kahn
	["Ragore Driftstalker"] = 84392; --Ragore Driftstalker
	["Rai'vosh"] = 82374; --Rai'vosh
	["Redclaw the Feral"] = 82755; --Redclaw the Feral
	["Rotcap"] = 85504; --Rotcap
	["Sangrikass"] = 84833; --Sangrikass
	["Scout Goreseeker"] = 77526; --Scout Goreseeker
	["Sean Whitesea"] = 83542; --Sean Whitesea
	["Shadowbark"] = 79938; --Shadowbark
	["Shinri"] = 82415; --Shinri
	["Sikthiss, Maiden of Slaughter"] = 78715; --Sikthiss, Maiden of Slaughter
	["Silverleaf Ancient"] = 79686; --Silverleaf Ancient
	["Silverleaf Ancient"] = 79693; --Silverleaf Ancient
	["Silverleaf Ancient"] = 79692; --Silverleaf Ancient
	["Solar Magnifier"] = 83990; --Solar Magnifier
	["Soulfang"] = 80057; --Soulfang
	["Steeltusk"] = 86549; --Steeltusk
	["Stomper Kreego"] = 79629; --Stomper Kreego
	["Stonespite"] = 84805; --Stonespite
	["Sulfurious"] = 80725; --Sulfurious
	["Sunclaw"] = 86137; --Sunclaw
	["Sunderthorn"] = 84912; --Sunderthorn
	["Swarmleaf"] = 85520; --Swarmleaf
	["Swift Onyx Flayer"] = 88582; --Swift Onyx Flayer
	["Talonbreaker"] = 84836; --Talonbreaker
	["Talonpriest Zorkra"] = 79485; --Talonpriest Zorkra
	["Tesska the Broken"] = 84775; --Tesska the Broken
	["The Beater"] = 77527; --The Beater
	["Tor'goroth"] = 82618; --Tor'goroth
	["Tura'aka"] = 83591; --Tura'aka
	["Varasha"] = 82050; --Varasha
	["Veloss"] = 75482; --Veloss
	["Voidreaver Urnae"] = 85078; --Voidreaver Urnae
	["Voidseer Kalurg"] = 83385; --Voidseer Kalurg
	["Vulceros"] = 77926; --Vulceros
	["Wandering Vindicator"] = 77776; --Wandering Vindicator
	["Warcaster Bargol"] = 78733; --Warcaster Bargol
	["Warmaster Blugthol"] = 79024; --Warmaster Blugthol
	["Windfang Matriarch"] = 75434; --Windfang Matriarch
	["Xothear, the Destroyer"] = 82922; --Xothear, the Destroyer
	["Yaga the Scarred"] = 79145; --Yaga the Scarred
	["Yazheera the Incinerator"] = 77529; --Yazheera the Incinerator
	["Yggdrel"] = 75435; --Yggdrel
	["Moonfang"] = 71992; --Moonfang
	["Ancient Inferno"] = 84875; --Ancient Inferno
	["Brickhouse"] = 83819; --Brickhouse
	["Demidos"] = 84911; --Demidos
	["Elder Darkweaver Kath"] = 85771; --Elder Darkweaver Kath
	["Goregore"] = 84893; --Goregore
	["Korthall Soulgorger"] = 84110; --Korthall Soulgorger
	["Kurlosh Doomfang"] = 82988; --Kurlosh Doomfang
	["Lady Demlash"] = 82942; --Lady Demlash
	["Mandragoraster"] = 83683; --Mandragoraster
	["Oraggro"] = 84904; --Oraggro
	["Orumo the Observer"] = 87668; --Orumo the Observer
	["Panthora"] = 83691; --Panthora
	["Shadowflame Terrorwalker"] = 82930; --Shadowflame Terrorwalker
	["Titarus"] = 83713; --Titarus
	["Vigilant Paarthos"] = 88436; --Vigilant Paarthos
	["Archmagus Tekar"] = 88072; --Archmagus Tekar
	["Bombardier Gu'gok"] = 87597; --Bombardier Gu'gok
	["Captured Gor'vosh Stoneshaper"] = 84746; --Captured Gor'vosh Stoneshaper
	["Cursed Harbinger"] = 85767; --Cursed Harbinger
	["Cursed Ravager"] = 85763; --Cursed Ravager
	["Cursed Sharptalon"] = 85766; --Cursed Sharptalon
	["Gibblette the Cowardly"] = 87352; --Gibblette the Cowardly
	["Gibby"] = 87362; --Gibby
	["Gug'tol"] = 83019; --Gug'tol
	["Hoarfrost"] = 87348; --Hoarfrost
	["Legion Vanguard"] = 88494; --Legion Vanguard
	["Master Sergeant Milgra"] = 85001; --Master Sergeant Milgra
	["Moltnoma"] = 82614; --Moltnoma
	["Mother of Goren"] = 87351; --Mother of Goren
	["Quartermaster Hershak"] = 84925; --Quartermaster Hershak
	["Shadowspeaker Niir"] = 85029; --Shadowspeaker Niir
	["Slogtusk the Corpse-Eater"] = 82617; --Slogtusk the Corpse-Eater
	["Son of Goramal"] = 82620; --Son of Goramal
	["Soulbinder Naylana"] = 88083; --Soulbinder Naylana
	["Strategist Ankor"] = 88071; --Strategist Ankor
	["The Bone Crawler"] = 78265; --The Bone Crawler
	["Blademaster Ro'gor"] = 86579; --Blademaster Ro'gor
	["Defector Dazgo"] = 86566; --Defector Dazgo
	["Durp the Hated"] = 86571; --Durp the Hated
	["Gorivax"] = 82536; --Gorivax
	["Horgg"] = 86577; --Horgg
	["Inventor Blammo"] = 86574; --Inventor Blammo
	["Maniacal Madgard"] = 86562; --Maniacal Madgard
	["Morgo Kain"] = 86582; --Morgo Kain
	["The Lanticore"] = 77081; --The Lanticore
	["Valkor"] = 87357; --Valkor
	["Vrok the Ancient"] = 87356; --Vrok the Ancient
	["Warlord Noktyn"] = 82883; --Warlord Noktyn
	["Ak'ox the Slaughterer"] = 84378; --Ak'ox the Slaughterer
	["Alkali"] = 86268; --Alkali
	["Avalanche"] = 85568; --Avalanche
	["Bonebreaker"] = 87837; --Bonebreaker
	["Burning Power"] = 84926; --Burning Power
	["Durg Spinecrusher"] = 87788; --Durg Spinecrusher
	["Gluttonous Giant"] = 87019; --Gluttonous Giant
	["Gnarljaw"] = 78269; --Gnarljaw
	["Gorg'ak the Lava Guzzler"] = 72364; --Gorg'ak the Lava Guzzler
	["Gortag Steelgrip"] = 87344; --Gortag Steelgrip
	["King Slime"] = 78260; --King Slime
	["Krahl Deadeye"] = 87239; --Krahl Deadeye
	["Leaping Gorger"] = 84465; --Leaping Gorger
	["Malgosh Shadowkeeper"] = 85451; --Malgosh Shadowkeeper
	["Mecha Plunderer"] = 87026; --Mecha Plunderer
	["Mogamago"] = 88586; --Mogamago
	["Mr. Pinchy Sr."] = 84435; --Mr. Pinchy Sr.
	["Nagidna"] = 85555; --Nagidna
	["Shadow Hulk"] = 87027; --Shadow Hulk
	["Slippery Slime"] = 84854; --Slippery Slime
	["Slivermaw"] = 85837; --Slivermaw
	["Soul-Twister Torek"] = 85026; --Soul-Twister Torek
	["Ug'lok the Frozen"] = 79104; --Ug'lok the Frozen
	["Web-wrapped Soldier"] = 84196; --Web-wrapped Soldier
	["Aogexon"] = 86774; --Aogexon
	["Basten"] = 86257; --Basten
	["Bergruu"] = 86732; --Bergruu
	["Borrok the Devourer"] = 72156; --Borrok the Devourer
	["Dekorhan"] = 86743; --Dekorhan
	["Echidna"] = 80372; --Echidna
	["Gagrog the Brutal"] = 86771; --Gagrog the Brutal
	["Keravnos"] = 80398; --Keravnos
	["Krud the Eviscerator"] = 88210; --Krud the Eviscerator
	["Lernaea"] = 80370; --Lernaea
	["Mu'gra"] = 87666; --Mu'gra
	["Nultra"] = 86258; --Nultra
	["Pit Slayer"] = 87846; --Pit Slayer
	["Thek'talon"] = 86750; --Thek'talon
	["Typhon"] = 80371; --Typhon
	["Valstil"] = 86259; --Valstil
	["Venolasix"] = 86266; --Venolasix
	["Vileclaw"] = 88951; --Vileclaw
	["Xelganak"] = 86835; --Xelganak
	["Captain Ironbeard"] = 79725; --Captain Ironbeard
	["Gaz'orda"] = 80122; --Gaz'orda
	["Netherspawn"] = 83401; --Netherspawn
	["Ru'klaa"] = 83526; --Ru'klaa
	["Windcaller Korast"] = 83428; --Windcaller Korast
	["Berserk T-300 Series Mark II"] = 82826; --Berserk T-300 Series Mark II
	["Explorer Nozzand"] = 82486; --Explorer Nozzand
	["Gorepetal"] = 83509; --Gorepetal
	["Graveltooth"] = 84263; --Graveltooth
	["Scout Pokhar"] = 83634; --Scout Pokhar
	["Gaze"] = 86978; --Gaze
	["Gobblefin"] = 84951; --Gobblefin
	["Grrbrrgle"] = 85572; --Grrbrrgle
	["Aarko"] = 77664; --Aarko
	["Echo of Murmur"] = 77828; --Echo of Murmur
	["Echo of Murmur"] = 77795; --Echo of Murmur
	["Shirzir"] = 79543; --Shirzir
	["Taladorantula"] = 77634; --Taladorantula
	["Underseer Bloodmane"] = 80524; --Underseer Bloodmane
	["Rolkor"] = 85264; --Rolkor
	["Sylldross"] = 86410; --Sylldross
	["Hive Queen Skrikka"] = 83522; --Hive Queen Skrikka
	["Broodmother Reeg'ak"] = 74613; --Broodmother Reeg'ak
	["Giantbane"] = 77519; --Giantbane
	["Sneevel"] = 86689; --Sneevel
	["Stompalupagus"] = 86520; --Stompalupagus
	["Berthora"] = 85907; --Berthora
	["Riptar"] = 85970; --Riptar
	["Hypnocroak"] = 79524; --Hypnocroak
	["Rockhoof"] = 72606; --Rockhoof
	["Venomshade"] = 75492; --Venomshade
	["Nakk the Thunderer"] = 50990; --Nakk the Thunderer
	["Gorok"] = 50992; --Gorok
	["Luk'hok"] = 50981; --Luk'hok
	["Poundfist"] = 50985; --Poundfist
	["Silthide"] = 51015; --Silthide
	["Pathrunner"] = 50883; --Pathrunner
	["Nok-Karosh"] = 81001; --Nok-Karosh
	
	-- Rares Draenor 6.2
	["Argosh the Destroyer"] = 91871; --Argosh the Destroyer
	["Belgork"] = 92552; --Belgork
	["Bilkor the Thrower"] = 90884; --Bilkor the Thrower
	["Bleeding Hollow Horror"] = 92657; --Bleeding Hollow Horror
	["Bloodhunter Zulk"] = 90936; --Bloodhunter Zulk
	["Broodlord Ixkor"] = 92429; --Broodlord Ixkor
	["Captain Grok'mar"] = 93264; --Captain Grok'mar
	["Captain Ironbeard"] = 93076; --Captain Ironbeard
	["Ceraxas"] = 90434; --Ceraxas
	["Cindral the Wildfire"] = 90519; --Cindral the Wildfire
	["Dark Summoner Rendkra"] = 90081; --Dark Summoner Rendkra
	["Dorg the Bloody"] = 90887; --Dorg the Bloody
	["Driss Vile"] = 93028; --Driss Vile
	["Drivnul"] = 90888; --Drivnul
	["Executor Riloth"] = 91727; --Executor Riloth
	["Felbore"] = 93168; --Felbore
	["Felsmith Damorka"] = 92647; --Felsmith Damorka
	["Felspark"] = 91098; --Felspark
	["Gloomtalon"] = 92508; --Gloomtalon
	["Gorabosh"] = 92941; --Gorabosh
	["Grand Warlock Nethekurse"] = 91695; --Grand Warlock Nethekurse
	["Grannok"] = 93057; --Grannok
	["Grobthok Skullbreaker"] = 90089; --Grobthok Skullbreaker
	["Harbormaster Korak"] = 90094; --Harbormaster Korak
	["High Priest Ikzan"] = 90281; --High Priest Ikzan
	["High Priest Ikzan"] = 90777; --High Priest Ikzan
	["Imp-Master Valessa"] = 90429; --Imp-Master Valessa
	["Iron Captain Argha"] = 90087; --Iron Captain Argha
	["Jax'zor"] = 90437; --Jax'zor
	["Krell the Serene"] = 92517; --Krell the Serene
	["Kris'kar the Unredeemed"] = 93279; --Kris'kar the Unredeemed
	["Lady Oran"] = 90438; --Lady Oran
	["Magwia"] = 93002; --Magwia
	["Mistress Thavra"] = 90442; --Mistress Thavra
	["Ormak Bloodbolt"] = 90088; --Ormak Bloodbolt
	["Overlord Ma'gruth"] = 92411; --Overlord Ma'gruth
	["Painmistress Selora"] = 92274; --Painmistress Selora
	["Podlord Wakkawam"] = 91374; --Podlord Wakkawam
	["Putre'thar"] = 91009; --Putre'thar
	["Rasthe"] = 90782; --Rasthe
	["Relgor"] = 92197; --Relgor
	["Remnant of the Blood Moon"] = 91227; --Remnant of the Blood Moon
	["Rendrak"] = 92627; --Rendrak
	["Rogond the Tracker"] = 90885; --Rogond the Tracker
	["Rukmaz"] = 94113; --Rukmaz
	["Sergeant Mor'grak"] = 90024; --Sergeant Mor'grak
	["Shadowthrash"] = 93236; --Shadowthrash
	["Soulslicer"] = 92495; --Soulslicer
	["Steelsnout"] = 92887; --Steelsnout
	["Sylissa"] = 92606; --Sylissa
	["Szirek the Twisted"] = 93001; --Szirek the Twisted
	["The Blackfang"] = 92465; --The Blackfang
	["The Goreclaw"] = 92694; --The Goreclaw
	["The Iron Houndmaster"] = 92977; --The Iron Houndmaster
	["The Night Haunter"] = 92645; --The Night Haunter
	["The Night Haunter"] = 92636; --The Night Haunter
	["Tho'gar Gorefist"] = 91243; --Tho'gar Gorefist
	["Thromma the Gutslicer"] = 92574; --Thromma the Gutslicer
	["Varyx the Damned"] = 92451; --Varyx the Damned
	["Xanzith the Everlasting"] = 92408; --Xanzith the Everlasting
	["Zeter'el"] = 91087; --Zeter'el
	["Zoug the Heavy"] = 90122; --Zoug the Heavy
	["Bramblefell"] = 91093; --Bramblefell
	["Commander Krag'goth"] = 91232; --Commander Krag'goth
	["Commander Org'mok"] = 89675; --Commander Org'mok
	["Deathtalon"] = 95053; --Deathtalon
	["Doomroller"] = 95056; --Doomroller
	["Glub'glok"] = 93125; --Glub'glok
	["Terrorfist"] = 95044; --Terrorfist
	["Vengeance"] = 95054; --Vengeance
	["Wyrmple"] = 91921; --Wyrmple
	["Xemirkol"] = 96235; --Xemirkol
	
	-- Rares Draenor 6.2.1
	["Guk"] = 98200; --Guk
	["Pugg"] = 98199; --Pugg
	["Rukdug"] = 98198; --Rukdug
	["Drakum"] = 98283; --Drakum
	["Gondar"] = 98284; --Gondar
	["Smashum Grabb"] = 98285; --Smashum Grabb
	["Fel Overseer Mudlump"] = 98408; --Fel Overseer Mudlump
	["Arachnis"] = 96323; --Arachnis
	["Eraakis"] = 97209; --Eraakis

	-- Rares Legion	
	["Drugon the Frostblood"] = 110378; --Drugon the Frostblood
	["Flotsam"] = 99929; --Flotsam
	["Humongris"] = 108879; --Humongris
	["Nithogg"] = 107544; --Nithogg
	["Shar'thos"] = 108678; --Shar'thos
	["\"Sure-Shot\" Arnie"] = 100230; --"Sure-Shot" Arnie
	["Abesha"] = 97348; --Abesha
	["Achronos"] = 112705; --Achronos
	["Aegir Wavecrusher"] = 108885; --Aegir Wavecrusher
	["Ala'washte"] = 104481; --Ala'washte
	["Alluvanon"] = 107960; --Alluvanon
	["Alteria"] = 104521; --Alteria
	["Ambassador D'vwinn"] = 111649; --Ambassador D'vwinn
	["Ambusher Daggerfang"] = 92611; --Ambusher Daggerfang
	["Anax"] = 111197; --Anax
	["Aodh Witherpetal"] = 110346; --Aodh Witherpetal
	["Apothecary Faldren"] = 110870; --Apothecary Faldren
	["Apothecary Perez"] = 92634; --Apothecary Perez
	["Arcana Stalker"] = 90173; --Arcana Stalker
	["Arcanist Lylandre"] = 110656; --Arcanist Lylandre
	["Arcanist Shal'iman"] = 107657; --Arcanist Shal'iman
	["Arcanor Prime"] = 109641; --Arcanor Prime
	["Arcavellus"] = 90244; --Arcavellus
	["Arru"] = 97220; --Arru
	["Arthfael"] = 99802; --Arthfael
	["Arthfael"] = 103801; --Arthfael
	["Artificer Lothaire"] = 106351; --Artificer Lothaire
	["Assassin Huwe"] = 92633; --Assassin Huwe
	["Auditor Esiel"] = 112758; --Auditor Esiel
	["Az'jatar"] = 112759; --Az'jatar
	["Baconlisk"] = 103787; --Baconlisk
	["Bahagar"] = 110562; --Bahagar
	["Barax the Mauler"] = 97637; --Barax the Mauler
	["Beacher"] = 91187; --Beacher
	["Bestrix"] = 111454; --Bestrix
	["Bilebrain"] = 107327; --Bilebrain
	["Bladesquall"] = 91874; --Bladesquall
	["Bloodstalker Alpha"] = 92599; --Bloodstalker Alpha
	["Bloody Raven"] = 98361; --Bloody Raven
	["Bodash the Hoarder"] = 98299; --Bodash the Hoarder
	["Boulderfall"] = 98178; --Boulderfall
	["Boulderfall, the Eroded"] = 109113; --Boulderfall, the Eroded
	["Brawlgoth"] = 107127; --Brawlgoth
	["Brinebeard the Risen"] = 106863; --Brinebeard the Risen
	["Bristlemaul"] = 97449; --Bristlemaul
	["Brogozog"] = 91100; --Brogozog
	["Brogrul the Mighty"] = 94877; --Brogrul the Mighty
	["Broodmother Lizax"] = 107105; --Broodmother Lizax
	["Broodmother Shu'malis"] = 105632; --Broodmother Shu'malis
	["Bruiser"] = 102863; --Bruiser
	["Bulvinkel"] = 111463; --Bulvinkel
	["Cadraeus"] = 110726; --Cadraeus
	["Cailyn Paledoom"] = 91289; --Cailyn Paledoom
	["Captain Brvet"] = 92685; --Captain Brvet
	["Captain Dargun"] = 109163; --Captain Dargun
	["Captain Volo'ren"] = 89846; --Captain Volo'ren
	["Champion Elodie"] = 92604; --Champion Elodie
	["Charfeather"] = 101596; --Charfeather
	["Chief Bitterbrine"] = 106990; --Chief Bitterbrine
	["Chief Treasurer Jabrill"] = 109677; --Chief Treasurer Jabrill
	["Cinderwing"] = 111674; --Cinderwing
	["Colerian"] = 104698; --Colerian
	["Colerian"] = 104519; --Colerian
	["Commander Soraax"] = 107266; --Commander Soraax
	["Cora'kar"] = 100864; --Cora'kar
	["Coruscating Bloom"] = 93778; --Coruscating Bloom
	["Count Nefarious"] = 97058; --Count Nefarious
	["Coura, Mistress of Arcana"] = 108255; --Coura, Mistress of Arcana
	["Crab Rider Grmlrml"] = 97933; --Crab Rider Grmlrml
	["Crawshuk the Hungry"] = 97345; --Crawshuk the Hungry
	["Crystalbeard"] = 90050; --Crystalbeard
	["Cyrilline"] = 105619; --Cyrilline
	["Daggerbeak"] = 90057; --Daggerbeak
	["Daniel \"Boomer\" Vorick"] = 94313; --Daniel "Boomer" Vorick
	["Dargok Thunderuin"] = 100231; --Dargok Thunderuin
	["Dark Ranger Jess"] = 92631; --Dark Ranger Jess
	["Darkest Fear"] = 92205; --Darkest Fear
	["Darkfiend Tormentor"] = 107924; --Darkfiend Tormentor
	["Darkful"] = 109501; --Darkful
	["Darkshade"] = 92965; --Darkshade
	["Deathguard Adams"] = 92626; --Deathguard Adams
	["Deepclaw"] = 109702; --Deepclaw
	["Defilia"] = 104513; --Defilia
	["Degren"] = 111651; --Degren
	["Den Mother Ylva"] = 108790; --Den Mother Ylva
	["Devious Sunrunner"] = 112637; --Devious Sunrunner
	["Devouring Darkness"] = 100495; --Devouring Darkness
	["Direclaw"] = 93088; --Direclaw
	["Doomlord Kazrok"] = 91579; --Doomlord Kazrok
	["Dorbash the Smasher"] = 109727; --Dorbash the Smasher
	["Dread Captain Thedon"] = 108543; --Dread Captain Thedon
	["Dread Corsair"] = 108541; --Dread Corsair
	["Dread Ship Krazatoa"] = 108531; --Dread Ship Krazatoa
	["Dread-Rider Cortis"] = 94347; --Dread-Rider Cortis
	["Dreadbog"] = 97517; --Dreadbog
	["Durguth"] = 96072; --Durguth
	["Ealdis"] = 110367; --Ealdis
	["Earlnoc the Beastbreaker"] = 96647; --Earlnoc the Beastbreaker
	["Egyl the Enduring"] = 98188; --Egyl the Enduring
	["Elfbane"] = 99792; --Elfbane
	["Enraged Earthservant"] = 93372; --Enraged Earthservant
	["Ettin"] = 109728; --Ettin
	["Fathnyr"] = 91803; --Fathnyr
	["Fathnyr"] = 98225; --Fathnyr
	["Felwing"] = 105938; --Felwing
	["Fenri"] = 92040; --Fenri
	["Fenri"] = 98276; --Fenri
	["Fjordun"] = 109584; --Fjordun
	["Fjorlag, the Grave's Chill"] = 108827; --Fjorlag, the Grave's Chill
	["Flamescale"] = 97793; --Flamescale
	["Flog the Captain-Eater"] = 89884; --Flog the Captain-Eater
	["Frostshard"] = 101649; --Frostshard
	["Fury"] = 109729; --Fury
	["Garvrulg"] = 99610; --Garvrulg
	["Gathenak the Subjugator"] = 93679; --Gathenak the Subjugator
	["General Volroth"] = 97370; --General Volroth
	["Glimar Ironfist"] = 91529; --Glimar Ironfist
	["Globulus"] = 95988; --Globulus
	["Golza the Iron Fin"] = 89816; --Golza the Iron Fin
	["Gom Crabbar"] = 101411; --Gom Crabbar
	["Gorebeak"] = 92117; --Gorebeak
	["Gorgroth"] = 110832; --Gorgroth
	["Grelda the Hag"] = 95123; --Grelda the Hag
	["Grimrot"] = 107595; --Grimrot
	["Grimrot"] = 107596; --Grimrot
	["Grimtotem Champion"] = 112708; --Grimtotem Champion
	["Grrvrgull the Conqueror"] = 98503; --Grrvrgull the Conqueror
	["Guardian Thor'el"] = 110944; --Guardian Thor'el
	["Gurbog da Basher"] = 96590; --Gurbog da Basher
	["Halfdan"] = 108823; --Halfdan
	["Hannval the Butcher"] = 107926; --Hannval the Butcher
	["Har'kess the Insatiable"] = 103214; --Har'kess the Insatiable
	["Harbinger of Screams"] = 110361; --Harbinger of Screams
	["Hartli the Snatcher"] = 97326; --Hartli the Snatcher
	["Hati"] = 103154; --Hati
	["Helmouth Raider"] = 92703; --Helmouth Raider
	["Helmouth Raider"] = 92682; --Helmouth Raider
	["Hertha Grimdottir"] = 103223; --Hertha Grimdottir
	["Hivequeen Zsala"] = 91649; --Hivequeen Zsala
	["Hook"] = 92590; --Hook
	["Horux"] = 107169; --Horux
	["Houndmaster Ely"] = 92951; --Houndmaster Ely
	["Houndmaster Stroxis"] = 107136; --Houndmaster Stroxis
	["Huk'roth the Huntmaster"] = 110486; --Huk'roth the Huntmaster
	["Huntress Estrid"] = 108822; --Huntress Estrid
	["Hydrannon"] = 100067; --Hydrannon
	["Image of Ursoc"] = 92199; --Image of Ursoc
	["Image of Ursol"] = 92200; --Image of Ursol
	["Imagined Horror"] = 92189; --Imagined Horror
	["Immolian"] = 109630; --Immolian
	["Infernal Lord"] = 90803; --Infernal Lord
	["Inquisitor Ernstenbok"] = 90139; --Inquisitor Ernstenbok
	["Inquisitor Tivos"] = 107269; --Inquisitor Tivos
	["Inquisitor Volitix"] = 106532; --Inquisitor Volitix
	["Insatiable Gorger"] = 93993; --Insatiable Gorger
	["Ironbranch"] = 93030; --Ironbranch
	["Isel the Hammer"] = 94413; --Isel the Hammer
	["Isel the Hammer"] = 109957; --Isel the Hammer
	["Ivory Sentinel"] = 92751; --Ivory Sentinel
	["Jade Darkhaven"] = 103975; --Jade Darkhaven
	["Jaggen-Ra"] = 101467; --Jaggen-Ra
	["Jak"] = 109500; --Jak
	["Jetsam"] = 103203; --Jetsam
	["Jinikki the Puncturer"] = 93686; --Jinikki the Puncturer
	["Jubei'thos"] = 96208; --Jubei'thos
	["Kalazzius the Guileful"] = 94636; --Kalazzius the Guileful
	["Karthax"] = 111731; --Karthax
	["Kathaw the Savage"] = 109125; --Kathaw the Savage
	["Kethrazor"] = 96997; --Kethrazor
	["King Forgalash"] = 101063; --King Forgalash
	["King Morgalash"] = 103827; --King Morgalash
	["King Voras"] = 97059; --King Voras
	["Kiranys Duskwhisper"] = 94414; --Kiranys Duskwhisper
	["Korda Torros"] = 96212; --Korda Torros
	["Kosumoth the Hungering"] = 111573; --Kosumoth the Hungering
	["Kottr Vondyr"] = 98421; --Kottr Vondyr
	["Kraxa"] = 103271; --Kraxa
	["Krol the Blade"] = 96210; --Krol the Blade
	["Kudzilla"] = 99362; --Kudzilla
	["Lady Rivantas"] = 106526; --Lady Rivantas
	["Lagertha"] = 109015; --Lagertha
	["Lieutenant Strathmar"] = 102303; --Lieutenant Strathmar
	["Lilin the Ravenous"] = 100516; --Lilin the Ravenous
	["Long-Forgotten Hippogryph"] = 108366; --Long-Forgotten Hippogryph
	["Luggut the Eggeater"] = 98024; --Luggut the Eggeater
	["Lyrath Moonfeather"] = 98241; --Lyrath Moonfeather
	["Lysanis Shadesoul"] = 111939; --Lysanis Shadesoul
	["Lytheron"] = 109692; --Lytheron
	["Mad Henryk"] = 95221; --Mad Henryk
	["Magister Phaedris"] = 109954; --Magister Phaedris
	["Magistrix Vilessa"] = 112757; --Magistrix Vilessa
	["Maia the White"] = 112497; --Maia the White
	["Majestic Elderhorn"] = 96410; --Majestic Elderhorn
	["Mal'Dreth the Corruptor"] = 110024; --Mal'Dreth the Corruptor
	["Malisandra"] = 109281; --Malisandra
	["Mar'tura"] = 112802; --Mar'tura
	["Marblub the Massive"] = 109653; --Marblub the Massive
	["Matron Hagatha"] = 111329; --Matron Hagatha
	["Mawat'aki"] = 104517; --Mawat'aki
	["Mellok, Son of Torok"] = 96621; --Mellok, Son of Torok
	["Miasu"] = 111653; --Miasu
	["Monstrous Plague Rat"] = 111055; --Monstrous Plague Rat
	["Mordvigbjorn"] = 93371; --Mordvigbjorn
	["Mortiferous"] = 93622; --Mortiferous
	["Mother Clacker"] = 91780; --Mother Clacker
	["Mrrgrl the Tide Reaver"] = 89865; --Mrrgrl the Tide Reaver
	["Mrrklr"] = 98311; --Mrrklr
	["Mynta Talonscreech"] = 97593; --Mynta Talonscreech
	["Myonix"] = 110340; --Myonix
	["Mythana"] = 101641; --Mythana
	["N.U.T.Z."] = 107477; --N.U.T.Z.
	["Necromagus Toldrethar"] = 108016; --Necromagus Toldrethar
	["Nightmare Crystal"] = 110451; --Nightmare Crystal
	["Nightmare WardenNOT SPAWNED"] = 106165; --Nightmare WardenNOT SPAWNED
	["Nithogg"] = 107023; --Nithogg
	["Normantis the Deposed"] = 90248; --Normantis the Deposed
	["Normantis the Deposed"] = 90217; --Normantis the Deposed
	["Normantis the Deposed"] = 90253; --Normantis the Deposed
	["Notgarn"] = 105657; --Notgarn
	["Nylaathria the Forgotten"] = 109990; --Nylaathria the Forgotten
	["Oglok the Furious"] = 105899; --Oglok the Furious
	["Ol' Eary"] = 108715; --Ol' Eary
	["Ol' Muddle"] = 107617; --Ol' Muddle
	["Olokk the Shipbreaker"] = 104484; --Olokk the Shipbreaker
	["Oreth the Vile"] = 110577; --Oreth the Vile
	["Ormagrogg"] = 104524; --Ormagrogg
	["Oubdob da Smasher"] = 95204; --Oubdob da Smasher
	["Overseer Brutarg"] = 97057; --Overseer Brutarg
	["Pacified Earth"] = 99886; --Pacified Earth
	["Pale Dreadwing"] = 110364; --Pale Dreadwing
	["Pashya"] = 113694; --Pashya
	["Perrexx"] = 95318; --Perrexx
	["Pinchshank"] = 107846; --Pinchshank
	["Plaguemaw"] = 103045; --Plaguemaw
	["Pollous the Fetid"] = 94485; --Pollous the Fetid
	["Powdermaster Maclin"] = 108010; --Powdermaster Maclin
	["Pridelord Meowl"] = 90901; --Pridelord Meowl
	["Priestess Liza"] = 92613; --Priestess Liza
	["Puck"] = 100302; --Puck
	["Quin'el, Master of Chillwind"] = 108256; --Quin'el, Master of Chillwind
	["Rabxach"] = 110342; --Rabxach
	["Rage Rot"] = 101660; --Rage Rot
	["Ragemaw"] = 109504; --Ragemaw
	["Raging Earth"] = 99846; --Raging Earth
	["Ragoul"] = 103199; --Ragoul
	["Ram'Pag"] = 97102; --Ram'Pag
	["Rampant Mandragora"] = 92140; --Rampant Mandragora
	["Randril"] = 111007; --Randril
	["Rauren"] = 105547; --Rauren
	["Ravyn-Drath"] = 89016; --Ravyn-Drath
	["Reef Lord Raj'his"] = 103575; --Reef Lord Raj'his
	["Rok'nash"] = 103183; --Rok'nash
	["Roteye"] = 110363; --Roteye
	["Rulf Bonesnapper"] = 109317; --Rulf Bonesnapper
	["Runeseer Sigvid"] = 109318; --Runeseer Sigvid
	["Ryael Dawndrifter"] = 100232; --Ryael Dawndrifter
	["Saepher"] = 111010; --Saepher
	["Saepher"] = 111069; --Saepher
	["Sailor's Nightmare"] = 100184; --Sailor's Nightmare
	["Sanaar"] = 105739; --Sanaar
	["Scythemaster Cil'raman"] = 105728; --Scythemaster Cil'raman
	["Sea King Tidross"] = 111434; --Sea King Tidross
	["Seersei"] = 92180; --Seersei
	["Sekhan"] = 101077; --Sekhan
	["Selenyi"] = 104522; --Selenyi
	["Selia, Master of Balefire"] = 108251; --Selia, Master of Balefire
	["Shadowquill"] = 103841; --Shadowquill
	["Shal'an"] = 109054; --Shal'an
	["Shalas'aman"] = 104523; --Shalas'aman
	["Shara Felbreath"] = 97093; --Shara Felbreath
	["Shellmaw"] = 91788; --Shellmaw
	["Shroudseeker"] = 103605; --Shroudseeker
	["Shroudseeker's Shadow"] = 108794; --Shroudseeker's Shadow
	["Shyama the Dreaded"] = 92090; --Shyama the Dreaded
	["Siegemaster Aedrin"] = 110438; --Siegemaster Aedrin
	["Silver Serpent"] = 111052; --Silver Serpent
	["Sinister Leyrunner"] = 112636; --Sinister Leyrunner
	["Sinker"] = 92591; --Sinker
	["Skul'vrax"] = 93654; --Skul'vrax
	["Skullhat"] = 95872; --Skullhat
	["Sludge Face"] = 111021; --Sludge Face
	["Slumber"] = 98890; --Slumber
	["Son of Goredome"] = 92725; --Son of Goredome
	["Sorallus"] = 112756; --Sorallus
	["Soulbinder Halldora"] = 109195; --Soulbinder Halldora
	["Soulfiend Tagerma"] = 108494; --Soulfiend Tagerma
	["Soulthirster"] = 97630; --Soulthirster
	["Starbuck"] = 107487; --Starbuck
	["Stormfeather"] = 109594; --Stormfeather
	["Stormtalon"] = 109994; --Stormtalon
	["Stormwing Matriarch"] = 91795; --Stormwing Matriarch
	["Sunbreeze [DO NOT SPAWN]"] = 98309; --Sunbreeze [DO NOT SPAWN]
	["Syphonus"] = 90505; --Syphonus
	["Tamed Coralback"] = 97928; --Tamed Coralback
	["Tarben"] = 98268; --Tarben
	["Taurson"] = 97653; --Taurson
	["Tenpak Flametotem"] = 97203; --Tenpak Flametotem
	["Thane Irglov the Merciless"] = 91892; --Thane Irglov the Merciless
	["The Muscle"] = 108136; --The Muscle
	["The Nameless King"] = 92763; --The Nameless King
	["The Oracle"] = 89850; --The Oracle
	["The Rat King"] = 111057; --The Rat King
	["The Whisperer"] = 109620; --The Whisperer
	["Theryssia"] = 92423; --Theryssia
	["Thondrax"] = 93205; --Thondrax
	["Tide Behemoth"] = 91114; --Tide Behemoth
	["Tide Behemoth"] = 91115; --Tide Behemoth
	["Tide Behemoth"] = 91113; --Tide Behemoth
	["Tideclaw"] = 110824; --Tideclaw
	["Tiptog the Lost"] = 93166; --Tiptog the Lost
	["Torrentius"] = 102064; --Torrentius
	["Tracker Jack"] = 92609; --Tracker Jack
	["Treasure Demon"] = 89407; --Treasure Demon
	["Tremblade"] = 95440; --Tremblade
	["Trubble"] = 91663; --Trubble
	["Turtle"] = 108881; --Turtle
	["Ultanok"] = 103247; --Ultanok
	["Undergrell Ringleader"] = 109708; --Undergrell Ringleader
	["Urgev the Flayer"] = 93401; --Urgev the Flayer
	["Valakar the Thirsty"] = 109575; --Valakar the Thirsty
	["Valitos"] = 109606; --Valitos
	["Valiyaka the Stormbringer"] = 89650; --Valiyaka the Stormbringer
	["Vicious Whale Shark"] = 99899; --Vicious Whale Shark
	["Vinyeaty"] = 91640; --Vinyeaty
	["Vinyeti"] = 91661; --Vinyeti
	["Vinyeti"] = 89906; --Vinyeti
	["Vis'ileth"] = 105496; --Vis'ileth
	["Volshax, Breaker of Will"] = 112760; --Volshax, Breaker of Will
	["Vorthax"] = 107113; --Vorthax
	["Vrykul Earthmaiden Spirit"] = 100224; --Vrykul Earthmaiden Spirit
	["Vrykul Earthshaper Spirit"] = 100223; --Vrykul Earthshaper Spirit
	["Warbringer Mox'na"] = 90164; --Warbringer Mox'na
	["Warlord Vatilash"] = 102092; --Warlord Vatilash
	["Weaponized Rabbot"] = 107431; --Weaponized Rabbot
	["Well-Fed Bear"] = 103785; --Well-Fed Bear
	["Whitewater Typhoon"] = 92152; --Whitewater Typhoon
	["Witchdoctor Grgl-Brgl"] = 109648; --Witchdoctor Grgl-Brgl
	["Wraithtalon"] = 97504; --Wraithtalon
	["Wrath-Lord Lekos"] = 97069; --Wrath-Lord Lekos
	["Xaander"] = 109498; --Xaander
	["Xavrix"] = 104831; --Xavrix
	["Zenobia"] = 100303; --Zenobia
	["Zorux"] = 107170; --Zorux
	["Crazed Mage"] = 97587; --Crazed Mage
	["Splint"] = 97380; --Splint
	["Thieving Scoundrel"] = 97390; --Thieving Scoundrel
	["Xullorax"] = 97388; --Xullorax
	["Segacedi"] = 97384; --Segacedi
	["Rotten Egg"] = 97589; --Rotten Egg
	["Mana Seeper"] = 97387; --Mana Seeper
	["Screek"] = 97381; --Screek
	
	-- Rares Legion 7.1.0
	["Ariadne"] = 115847; --Ariadne
	["Attendant Keeper"] = 116185; --Attendant Keeper
	["Doomlash"] = 115853; --Doomlash
	["Exotic Concubine"] = 116230; --Exotic Concubine
	["Flightmaster Volnath"] = 116004; --Flightmaster Volnath
	["Kar'zun"] = 116008; --Kar'zun
	["Nightwell Diviner"] = 116395; --Nightwell Diviner
	["Regal Cloudwing"] = 116036; --Regal Cloudwing
	["Regal Cloudwing"] = 116059; --Regal Cloudwing
	["The Cow King"] = 116034; --The Cow King
	["Torm the Brute"] = 115914; --Torm the Brute
	["Tower Concubine"] = 116158; --Tower Concubine
	["Treasure Goblin"] = 116652; --Treasure Goblin
	["Wily Sycophant"] = 116159; --Wily Sycophant
	["Wrymtongue Hoarder"] = 89407; --Wrymtongue Hoarder
	["Treasure Goblin"] = 116041; --Treasure Goblin
	
	-- Rares Legion 7.1.5
	["Lightning Paw"] = 118244; --Lightning Paw
	["Lorthalium"] = 115537; --Lorthalium
	
	-- Rares Legion 7.2.0
	["Apocron"] = 121124; --Apocron
	["Malificus"] = 117303; --Malificus
	["Si'vash"] = 117470; --Si'vash
	["Abyssal Ember"] = 116666; --Abyssal Ember
	["An'thyna"] = 120675; --An'thyna
	["Angered Sea Giant"] = 116657; --Angered Sea Giant
	["Anomalous Observer"] = 121092; --Anomalous Observer
	["Aqueux"] = 121016; --Aqueux
	["Baleful Knight-Captain"] = 121049; --Baleful Knight-Captain
	["Brood Mother Nix"] = 121029; --Brood Mother Nix
	["Brother Badatin"] = 121046; --Brother Badatin
	["Brutallus"] = 117239; --Brutallus
	["Corrupted Bonebreaker"] = 116953; --Corrupted Bonebreaker
	["Deepmaw"] = 120022; --Deepmaw
	["Demented Shivarra"] = 121090; --Demented Shivarra
	["Deranged Succubus"] = 121073; --Deranged Succubus
	["Doombringer Zar'thoz"] = 117136; --Doombringer Zar'thoz
	["Dreadblade Annihilator"] = 117095; --Dreadblade Annihilator
	["Dreadeye"] = 118993; --Dreadeye
	["Dreadspeaker Serilis"] = 120716; --Dreadspeaker Serilis
	["Dresanoth"] = 120012; --Dresanoth
	["Duke Sithizi"] = 121134; --Duke Sithizi
	["Emberfire"] = 117086; --Emberfire
	["Emberon"] = 116671; --Emberon
	["Erdu'val"] = 120020; --Erdu'val
	["Eye of Gurgh"] = 116166; --Eye of Gurgh
	["Fel Obliterator"] = 120681; --Fel Obliterator
	["Felbringer Xar'thok"] = 117093; --Felbringer Xar'thok
	["Felcaller Zelthae"] = 117103; --Felcaller Zelthae
	["Felhound"] = 117342; --Felhound
	["Felmaw Emberfiend"] = 117091; --Felmaw Emberfiend
	["Flllurlokkr"] = 120998; --Flllurlokkr
	["Force-Commander Xillious"] = 120665; --Force-Commander Xillious
	["Grimtotem Warrior"] = 117493; --Grimtotem Warrior
	["Grossir"] = 121037; --Grossir
	["Harth Stonebrew"] = 118675; --Harth Stonebrew
	["Illisthyndria"] = 120686; --Illisthyndria
	["Imp Mother Bruva"] = 119718; --Imp Mother Bruva
	["Inquisitor Chillbane"] = 117089; --Inquisitor Chillbane
	["Jorvild the Trusted"] = 115732; --Jorvild the Trusted
	["Kelpfist"] = 120021; --Kelpfist
	["Lady Eldrathe"] = 121107; --Lady Eldrathe
	["Lambent Felhunter"] = 121077; --Lambent Felhunter
	["Larithia"] = 120712; --Larithia
	["Lord Hel'Nurath"] = 119629; --Lord Hel'Nurath
	["Malformed Terrorguard"] = 121056; --Malformed Terrorguard
	["Malgrazoth"] = 117141; --Malgrazoth
	["Malorus the Soulkeeper"] = 117094; --Malorus the Soulkeeper
	["Mistress Dominix"] = 120717; --Mistress Dominix
	["Mo'arg Brute"] = 116912; --Mo'arg Brute
	["Mor'tec the Soulslaver"] = 116668; --Mor'tec the Soulslaver
	["Potionmaster Gloop"] = 117096; --Potionmaster Gloop
	["Raga'yut"] = 120715; --Raga'yut
	["Ruinous Overfiend"] = 121108; --Ruinous Overfiend
	["Ryul the Fading"] = 120019; --Ryul the Fading
	["Salethan the Broodwalker"] = 117140; --Salethan the Broodwalker
	["Simone the Seductress"] = 117850; --Simone the Seductress
	["Skulguloth"] = 120641; --Skulguloth
	["Somber Dawn"] = 121112; --Somber Dawn
	["Than'otalion"] = 120583; --Than'otalion
	["The Dread Stalker"] = 120013; --The Dread Stalker
	["Unstable Abyssal"] = 121051; --Unstable Abyssal
	["Volatile Imp"] = 121068; --Volatile Imp
	["Wa'glur"] = 120713; --Wa'glur
	["Warlord Darjah"] = 120003; --Warlord Darjah
	["Warped Voidlord"] = 121088; --Warped Voidlord
	["Xorogun the Flamecarver"] = 117090; --Xorogun the Flamecarver
	["Zirux"] = 116316; --Zirux
	["Gilded Guardian"] = 112712; --Gilded Guardian
	
	-- Rares Legion 7.2.5
	["Al'Abas"] = 123087; --Al'Abas
	["Bloodfeast"] = 122524; --Bloodfeast
	["Bonesunder"] = 122521; --Bonesunder
	["Death Metal Knight"] = 122899; --Death Metal Knight
	["Dregmar Runebrand"] = 122519; --Dregmar Runebrand
	["Icefist"] = 122520; --Icefist
	["Iceshatter"] = 122522; --Iceshatter
	["Xavinox"] = 122609; --Xavinox
	
	-- Rares Legion 7.3.0
	["Admiral Rel'var"] = 127090; --Admiral Rel'var
	["All-Seer Xanarian"] = 127096; --All-Seer Xanarian
	["Ataxon"] = 126887; --Ataxon
	["Baruut the Bloodthirsty"] = 126862; --Baruut the Bloodthirsty
	["Blistermaw"] = 122958; --Blistermaw
	["Blisterwing"] = 124479; --Blisterwing
	["Captain Faruq"] = 126869; --Captain Faruq
	["Chief Alchemist Munculus"] = 127376; --Chief Alchemist Munculus
	["Commander Endaxis"] = 124775; --Commander Endaxis
	["Commander Sathrenael"] = 122912; --Commander Sathrenael
	["Commander Texlaz"] = 127084; --Commander Texlaz
	["Commander Vecaya"] = 122911; --Commander Vecaya
	["Commander Xethgar"] = 126910; --Commander Xethgar
	["Darkcaller"] = 122457; --Darkcaller
	["Doomcaster Suprax"] = 127703; --Doomcaster Suprax
	["Everburning Doombringer"] = 127341; --Everburning Doombringer
	["Executioner Vaal"] = 124717; --Executioner Vaal
	["Eye of the Torturer"] = 124684; --Eye of the Torturer
	["Feasel the Muffin Thief"] = 126864; --Feasel the Muffin Thief
	["Gar'zoth"] = 122999; --Gar'zoth
	["Herald of Chaos"] = 126896; --Herald of Chaos
	["Houndcaller Orox"] = 124412; --Houndcaller Orox
	["Houndmaster Kerrax"] = 127288; --Houndmaster Kerrax
	["Imp Mother Laglath"] = 125820; --Imp Mother Laglath
	["Inquisitor Vethroz"] = 126946; --Inquisitor Vethroz
	["Instructor Tarahna"] = 126900; --Instructor Tarahna
	["Jed'hin Champion Vorusk"] = 126899; --Jed'hin Champion Vorusk
	["Kaara the Pale"] = 126860; --Kaara the Pale
	["Khazaduum"] = 125824; --Khazaduum
	["Lieutenant Xakaar"] = 126254; --Lieutenant Xakaar
	["Mistress Il'thendra"] = 122947; --Mistress Il'thendra
	["Mother Rosula"] = 127705; --Mother Rosula
	["Naroua"] = 126419; --Naroua
	["Overseer Y'Beda"] = 124440; --Overseer Y'Beda
	["Overseer Y'Morna"] = 125498; --Overseer Y'Morna
	["Overseer Y'Sorna"] = 125497; --Overseer Y'Sorna
	["Puscilla"] = 126040; --Puscilla
	["Pyromancer Volarr"] = 124572; --Pyromancer Volarr
	["Rezira the Seer"] = 127706; --Rezira the Seer
	["Sabuul"] = 126898; --Sabuul
	["Shadowcaster Voruun"] = 122838; --Shadowcaster Voruun
	["Siegemaster Voraan"] = 120393; --Siegemaster Voraan
	["Sister Subversia"] = 123464; --Sister Subversia
	["Skreeg the Devourer"] = 126912; --Skreeg the Devourer
	["Slithon the Last"] = 126913; --Slithon the Last
	["Sorolis the Ill-Fated"] = 126889; --Sorolis the Ill-Fated
	["Soultender Videx"] = 127704; --Soultender Videx
	["Soultwisted Monstrosity"] = 126815; --Soultwisted Monstrosity
	["Squadron Commander Vishax"] = 127700; --Squadron Commander Vishax
	["Talestra the Vile"] = 123689; --Talestra the Vile
	["Tar Spitter"] = 125479; --Tar Spitter
	["Tereck the Selector"] = 124804; --Tereck the Selector
	["The Many-Faced Devourer"] = 127581; --The Many-Faced Devourer
	["Turek the Lucid"] = 126868; --Turek the Lucid
	["Twilight-Harbinger Tharuul"] = 127906; --Twilight-Harbinger Tharuul
	["Tyrannosaurus Rekt"] = 126691; --Tyrannosaurus Rekt
	["Umbraliss"] = 126885; --Umbraliss
	["Vagath the Betrayed"] = 125388; --Vagath the Betrayed
	["Varga"] = 126208; --Varga
	["Ven'orn"] = 126115; --Ven'orn
	["Venomtail Skyfin"] = 126867; --Venomtail Skyfin
	["Vigilant Kuro"] = 126866; --Vigilant Kuro
	["Vigilant Thanos"] = 126865; --Vigilant Thanos
	["Vixx the Collector"] = 127882; --Vixx the Collector
	["Void Warden Valsuran"] = 127300; --Void Warden Valsuran
	["Void-Blade Zedaat"] = 127911; --Void-Blade Zedaat
	["Voidmaw"] = 122456; --Voidmaw
	["Vrax'thul"] = 126199; --Vrax'thul
	["Watcher Aival"] = 127291; --Watcher Aival
	["Worldsplitter Skuul"] = 127118; --Worldsplitter Skuul
	["Wrangler Kravos"] = 126852; --Wrangler Kravos
	["Wrath-Lord Yarez"] = 126338; --Wrath-Lord Yarez
	["Zul'tan the Numerous"] = 126908; --Zul'tan the Numerous
	["Zul'zoloth"] = 124680; --Zul'zoloth
	
	-- Rares Legion 7.3.5
	["Grand Marshal Tremblade"] = 133044; --Grand Marshal Tremblade
	["High Warlord Volrath"] = 133043; --High Warlord Volrath
	["Obsidian Deathwarder"] = 125951; --Obsidian Deathwarder
	["Ogmot the Mad"] = 132591; --Ogmot the Mad
	["Qroshekx"] = 132578; --Qroshekx
	["Sky Marshall Gabriel"] = 133042; --Sky Marshall Gabriel
	["Ssinkrix"] = 132580; --Ssinkrix
	["Xaarshej"] = 132584; --Xaarshej
}

if (type(AL["RARE_LIST"]) ~= "table") then
	AL["RARE_LIST"] = AL["EN_RARE_LIST"];
end
